// **************************************************************************
// * This file is part of the FreeFileSync project. It is distributed under *
// * GNU General Public License: http://www.gnu.org/licenses/gpl.html       *
// * Copyright (C) ZenJu (zhnmju123 AT gmx DOT de) - All Rights Reserved    *
// **************************************************************************

#include "thumbnail.h"
#include <Windows.h>
#include <zen/dll.h>

using namespace thumb;


int main()
{
    //1. Initialize COM
    ::CoInitializeEx(NULL, COINIT_APARTMENTTHREADED | COINIT_DISABLE_OLE1DDE); //-> should work
    //::CoInitializeEx(NULL, COINIT_MULTITHREADED | COINIT_DISABLE_OLE1DDE); //-> this should crash later
    //::CoInitialize(NULL);  //-> should work

    //2. Initialize system image list
    typedef BOOL (WINAPI *FileIconInitFun)(BOOL fRestoreCache);
    const util::DllFun<FileIconInitFun> fileIconInit(L"Shell32.dll", reinterpret_cast<LPCSTR>(660));
    if (fileIconInit)
        fileIconInit(false); //TRUE to restore the system image cache from disk; FALSE otherwise.

    //3. test
    //const wchar_t filename[] = L"C:\\Users\\ZenJu\\Desktop\\wxMSW-2.8.8\\1wxMSW-2.8.8.lnk";
    //const wchar_t filename[] = L"C:\\Users\\ZenJu\\Desktop\\wxMSW-2.8.8\\afiesta_cumple5.jpg";
    const wchar_t filename[] = L"C:\\Users\\ZenJu\\Desktop\\Neuer Ordner\\1~$TeXnicCenter Project (neu) - Kopie.tcp";

    thumb::HICON hIco = getThumbnail(filename, 48); //return 0 on failure, caller takes ownership!
    (void)hIco;

    SHFILEINFO fileInfo = {};
    DWORD_PTR imgList = ::SHGetFileInfo(filename,
                                        0,
                                        &fileInfo,
                                        sizeof(fileInfo),
                                        SHGFI_SYSICONINDEX);
    (void)imgList;

    thumb::HICON hIco2 = getIconByIndex(fileInfo.iIcon, SHIL_JUMBO); //return 0 on failure, caller takes ownership!
    (void)hIco2;

    ::CoUninitialize();
    return 0;
}
